import os,sys
from xml.dom.minidom import parse, parseString
import matplotlib.pyplot as plt
from SensorMedia import sensor
from SensordataMedia import sensordata
import matplotlib.dates as mdates
from datetime import datetime
import time

# Hacemos la lista de objetos sensores
def DoListSensor(NumberSensor):
	for i in NumberSensor:
		ListSensor.add(sensor(i))
		
# Obtenemos el numero de sensores de los que recogemos datos
def ListNumberSensor(arg):	
	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Obtenemos el arbol Dom y  comprobamos que tengamos todos los nodos hijos que tiene que aparecer, si no se da por mala la informacion obtenida en este envio y se obvia.
	for i in listEntry:
		b = False
		try:
			Nodedate = i.getElementsByTagName('date')[0]
			Nodeclock = i.getElementsByTagName('clock')[0]
			Nodesensor = i.getElementsByTagName('sensor')[0] 
			Nodehumedity = i.getElementsByTagName('humedity')[0]
			Nodetemperature = i.getElementsByTagName('temperature')[0]

		except IndexError:
			b=True
		if(b == True):
			continue
		#Si no da error, introducimos los numeros de los sensores, para crear una lista	
		Sensor = Nodesensor.childNodes[0].nodeValue
		NumberSensor.add(int(Sensor))


#Dibujamos los datos
def Draw(Datas):
	ListData = Datas.getListData()
	ArrayX = list()
	ArrayHUM = list()
	ArrayTEM = list()
	for i in ListData:
		# Obtenemos las fechas para el eje X y humedad y temperatura, para introducirlo como ejes Y, y ser dos graficas en una misma.
		ArrayX.append(i.getDate())
		ArrayHUM.append(i.getHum())
		ArrayTEM.append(i.getTemp())
	years = mdates.YearLocator()   # Por anyo, esto se crea para dar los limites de las graficas
	months = mdates.MonthLocator()  # Idem pero para los meses
	days = mdates.DayLocator()
	hours = mdates.HourLocator()
	minutes = mdates.MinuteLocator()
	Fmt = mdates.DateFormatter('%Y-%m-%d') # Creamos formato, para que se muestren las fechas asi en el eje X
	fig = plt.figure()
	ax = fig.add_subplot(111)
	ax.plot(ArrayX, ArrayHUM,'-o')
	lines = ax.plot(ArrayX, ArrayTEM,'-o') # Dibujamos con eje X las fechas y eje Y las datos humedad
	plt.setp(lines, color='r', linewidth=2.0) # Dibujamos en la misma grafica pero ahora el eje Y es temperatura y la dibujamos de color rojo
	# format the ticks
	if(len(ArrayX)!=1):
	# Buscamos el limite por debajo y el limite superior, para que la grafica no empiece por el primer dato obtenido si no por un dato del dia antes y el dia despues de lo obtenido.
		datemin = datetime(9999,12,1,1,1,1)
		datemax = datetime(1,1,1,1,1,1)
		ax.xaxis.set_major_locator(days)
		ax.xaxis.set_major_formatter(Fmt)
		ax.xaxis.set_minor_locator(hours)
		# Colocamos el valor de  referencia de minimo y maximo en la grafica, en este caso es la hora y el minuto
		for d in ArrayX:
			if(datemin.year>=d.year):
				if(datemin.month>=d.month):
					datemin = d
			if(datemax.year<=d.year):
				if(datemax.day<=d.day):
					datemax=d
		if(datemin.month==1):
			datemin = datetime(datemin.year-1,12,datemin.day,datemin.hour,datemin.minute,datemin.second)
		else:
			datemin = datetime(datemin.year,datemin.month-1,datemin.day,datemin.hour,datemin.minute,datemin.second)
		if(datemax.month==12):
			datemax = datetime(datemax.year+1,1,datemax.day,datemax.hour,datemax.minute,datemax.second)
		else:
			datemax = datetime(datemax.year,datemax.month+1,datemax.day,datemax.hour,datemax.minute,datemax.second)
				
		ax.set_xlim(datemin, datemax)
		
	# Formato de coordenadas de la grafica, pero la representacion no guardada
	def price(x): return '%1.2f'%x
	ax.format_xdata = mdates.DateFormatter('%Y-%m-%d %H:%M:%S')
	ax.format_ydata = price
	ax.grid(True)
	fig.autofmt_xdate()
	leg = ax.legend(('Humedity', 'Temperature'),
           'best', shadow=True)
	# Creamos la leyenda que aparece en las graficas
	plt.savefig('grafic'+str(Datas.getNumberSensor())+'.png')	
	plt.clf()
		
def parser(arg):	
	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Obtenemos el arbol Dom
	if(len(listEntry)!=0):
		for i in listEntry:
			b = False
			try:
				# Comprobamos que los datos obtenidos, estan completos.
				Nodedate = i.getElementsByTagName('date')[0]
				Nodeclock = i.getElementsByTagName('clock')[0]
				Nodesensor = i.getElementsByTagName('sensor')[0] 
				Nodehumedity = i.getElementsByTagName('humedity')[0]
				Nodetemperature = i.getElementsByTagName('temperature')[0]
			except IndexError:
				b = True
				# Si no pues volvemos ha iterar al siguiente nodo
			if(b == True):
				continue
			Date = Nodedate.childNodes[0].nodeValue
			Clock = Nodeclock.childNodes[0].nodeValue 
			Sensor = Nodesensor.childNodes[0].nodeValue
			Humedity = Nodehumedity.childNodes[0].nodeValue
			Temperature = Nodetemperature.childNodes[0].nodeValue
			# Obtenemos los valores de los nodos, y los guardamos en la lista de datos del objeto sensor correspondiente
			for i in ListSensor:
			# Iteramos en la lista de sensores, comprobamos que sea igual y si es el objeto sensor que queremos, creamos el objeto sensordata y lo introducimos en la lista de datos que tiene el objeto sensor 
				if(i.getNumberSensor()==int(Sensor)):
					SensorData = sensordata(Clock+' '+Date, Humedity, Temperature) 
					i.inputData(SensorData)
	else:
		print 'No hay datos para parsear'			
# Iteramos en los argumentos de entrada
if (len(sys.argv) == 1):
	print "Usage: " + sys.argv[0] + " fichero1.xml ... fichero2.xml"
	sys.exit
else:
	NumberSensor = set()
	ListSensor = set()
	for arg in range(1,len(sys.argv)):
		ListNumberSensor(sys.argv[arg])
	DoListSensor(NumberSensor)
	# Inicializamos las estructuras almacenamiento de datos que tenemos que usar para el parser
	for arg in range(1,len(sys.argv)):
		parser(sys.argv[arg])
	if(len(ListSensor)==0):
		sys.exit
	else:
		for i in ListSensor:
			Draw(i)

